from paddlex_hps_server import BaseTritonPythonModel
from paddlex_hps_server.storage import create_storage

# Do we need a lock?
DEFAULT_INDEX_DIR = ".indexes"


class BaseFaceRecognitionModel(BaseTritonPythonModel):
    def initialize(self, args):
        super().initialize(args)
        self._context = {}
        if self._app_config.extra and "index_storage" in self._app_config.extra:
            self._context["index_storage"] = create_storage(
                self._app_config.extra["index_storage"]
            )
        else:
            self._context["index_storage"] = create_storage(
                {"type": "file_system", "directory": DEFAULT_INDEX_DIR}
            )
